leetcode【213】【tag DP】House Robber II【c++版本,時間O(n),空間O(1)】

問題描述:

You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed. All houses at this place are arranged in a circle. That means the first house is the neighbor of the last one. Meanwhile, adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.

Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.

Example 1:

Input: [2,3,2]
Output: 3
Explanation: You cannot rob house 1 (money = 2) and then rob house 3 (money = 2),
             because they are adjacent houses.

Example 2:

Input: [1,2,3,1]
Output: 4
Explanation: Rob house 1 (money = 1) and then rob house 3 (money = 3).
             Total amount you can rob = 1 + 3 = 4.

源碼:

自己高騰了半天,沒搞出來,最後還是翻了一下人家的博客。

對上一題不瞭解的同學可以先看一下這個leetcode【198】【tag DP】House Robber【c++版本,動態規劃,時間空間O(n)均100%】。這題加了一個限制條件就是頭尾屬於鄰居。

這時候選0就不能選n-1,相當於啊求[0,n-2]之間的最大值。選n-1就不能選0,相當於求[1,n-1]之間的最大值。

有個小技巧,對動態規劃降維,因爲動態規劃只用到了前兩個狀態,所以只需要一個a和一個b來存儲前兩個狀態即可。

class Solution {
public:
    int help(vector<int>& nums, int left, int right){
        int a=nums[left], b=max(nums[left], nums[left+1]);
        for (int i=left+2; i<=right; i++){
            int tmp = max(a+nums[i], b);
            a = b;
            b = tmp;
        }
        return b;
    }
    
    int rob(vector<int>& nums) {
        int n = nums.size();
        if (n==0)   return 0;
        if (n==1)   return nums[0];
        if (n==2)   return max(nums[0], nums[1]);
        return max(help(nums, 0, n-2), help(nums, 1, n-1));
    }
};

 

發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章